/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License).  You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 */

package org.jvnet.glassfish.comms.admin.management.extensions;

/**
 * All the new SIP XTypes are defined here.
 */

public class SIPXTypes {

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.SIPServiceConfig}
     */
    public final static String      SIP_SERVICE_CONFIG  =  "X-SIPServiceConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.SIPListenerConfig}
     */
    public final static String      SIP_LISTENER_CONFIG =  "X-SIPListenerConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.SIPProtocolConfig}
     */
    public final static String      SIP_PROTOCOL_CONFIG =  "X-SIPProtocolConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.SIPLinkConfig}
     */
    public final static String      SIP_LINK_CONFIG =  "X-SIPLinkConfig";
 
    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.SIPTimersConfig}
     */
    public final static String      SIP_TIMERS_CONFIG =  "X-SIPTimersConfig";

     /**
         ID for {@link org.jvnet.glassfish.comms.management.config.SIPContainerConfig}
     */
    public final static String      SIP_CONTAINER_CONFIG =  "X-SIPContainerConfig";

     /**
         ID for {@link org.jvnet.glassfish.comms.management.config.SIPContainerAvailabilityConfig}
     */
    public final static String      SIP_CONTAINER_AVAILABILITY_CONFIG =  "X-SIPContainerAvailabilityConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.ConvergedLBConfig}
     */
    public final static String      CONVERGED_LB_CONFIG =  "X-ConvergedLBConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.ConvergedLoadBalancerConfig}
     */
    public final static String      CONVERGED_LOAD_BALANCER_CONFIG =  "X-ConvergedLoadBalancerConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.ConvergedLBClusterRefConfig}
     */
    public final static String      CONVERGED_LB_CLUSTER_REF_CONFIG =  "X-ConvergedLBClusterRefConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.ConvergedLBPolicyConfig}
     */
    public final static String      CONVERGED_LB_POLICY_CONFIG =  "X-ConvergedLBPolicyConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.ProxyConfig}
     */
    public final static String      PROXY_CONFIG =  "X-ProxyConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.IdentityAssertionTrustConfig}
     */
    public final static String      IDENTITY_ASSERTION_TRUST_CONFIG =  "X-IdentityAssertionTrustConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.TrustedEntityConfig}
     */
    public final static String      TRUSTED_ENTITY_CONFIG =  "X-TrustedEntityConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.config.TrustHandlerConfig}
     */
    public final static String      TRUST_HANDLER_CONFIG =  "X-TrustHandlerConfig";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.monitor.SIPServiceMonitor}
     */
    public final static String      SIP_SERVICE_MONITOR =  "X-SIPServiceMonitor";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.monitor.NetworkManagerMonitor}
     */
    public final static String      NETWORK_MANAGER_MONITOR =  "X-NetworkManagerMonitor";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.monitor.DialogManagerMonitor}
     */
    public final static String      DIALOG_MANAGER_MONITOR =  "X-DialogManagerMonitor";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.monitor.TransactionManagerMonitor}
     */
    public final static String      TRANSACTION_MANAGER_MONITOR =  "X-TransactionManagerMonitor";

    /**
         ID for {@link org.jvnet.glassfish.comms.management.monitor.OverloadProtectionManagerMonitor}
     */
    public final static String      OVERLOAD_PROTECTION_MANAGER_MONITOR =  "X-OverloadProtectionManagerMonitor";
}
