/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License).  You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 */
 
package org.jvnet.glassfish.comms.admin.management.extensions.config;

import java.util.Map;

import javax.management.ObjectName;

import com.sun.enterprise.management.config.AMXConfigImplBase;
import com.sun.enterprise.management.config.ConfigFactoryCallback;
import com.sun.enterprise.management.support.Delegate;
import com.sun.appserv.management.base.Util;

import org.jvnet.glassfish.comms.management.config.ConvergedLBConfig;
import org.jvnet.glassfish.comms.admin.management.extensions.SIPXTypes;

/**
 *    Configuration for the &lt;converged-lb-config&gt; element.
 */
public final class ConvergedLBConfigImpl extends AMXConfigImplBase
    implements ConfigFactoryCallback
{
    public ConvergedLBConfigImpl(final Delegate delegate)
    {
        super(delegate );
    }

    private ConvergedLBConfig getProxy()
    {
        return getProxy( getObjectName(), ConvergedLBConfig.class);
    }

    public Map<String,ObjectName>       getConvergedLBClusterRefConfigObjectNameMap() {
        return(getContaineeObjectNameMap(SIPXTypes.CONVERGED_LB_CLUSTER_REF_CONFIG));
    }

    private ConvergedLBClusterRefConfigFactory getConvergedLBClusterRefConfigFactory() {
        return new ConvergedLBClusterRefConfigFactory(this);
    }

    public void removeConvergedLBClusterRefConfig( final String name) {
        final Map<String,ObjectName> items = getConvergedLBClusterRefConfigObjectNameMap();
        getConvergedLBClusterRefConfigFactory().remove(Util.getObjectName(items, name));
    }
}
