/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License).  You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 */

package org.jvnet.glassfish.comms.admin.management.extensions.support.oldconfig;

import java.util.Properties;
import javax.management.NotificationListener;
import javax.management.ObjectName;
import javax.management.AttributeList;
import javax.management.NotificationFilter;
import javax.management.MBeanNotificationInfo;

import com.sun.enterprise.management.support.oldconfig.OldProperties;
import com.sun.enterprise.management.support.oldconfig.OldConfigsMBean;

public interface OldSIPConfigsMBean
// extends OldConfigsMBean
{

// -------------------- Operations --------------------

    public ObjectName createIdentityAssertionTrust( final AttributeList param1, final AttributeList param2, final Properties param3, final String param4);
    public void deleteIdentityAssertionTrust(  final String param1, final String param2); 
    public Object[] listIdentityAssertionTrusts(  final String param1, final String param2); 

    public boolean createTrustedEntity( final AttributeList param1, final String param2, final String param3);
    public boolean deleteTrustedEntity ( final String param1, final String param2, final String param3);

    public void    addNotificationListener( final NotificationListener param1, final NotificationFilter param2, final Object param3 );
    public ObjectName    createAccessLog( final AttributeList attribute_list );
    public ObjectName    createConnectionPool( final AttributeList attribute_list );
    public ObjectName    createSIPListener( final AttributeList attribute_list );
    public ObjectName    createSIPProtocol( final AttributeList attribute_list );
    public ObjectName    createKeepAlive( final AttributeList attribute_list );
    public ObjectName    createRequestProcessing( final AttributeList attribute_list );
    public boolean    destroyConfigElement();
    public ObjectName    getAccessLog();
    public ObjectName    getConnectionPool();
    public ObjectName[]    getSIPListener();
    public ObjectName    getSIPListenerById( final String key );
    public ObjectName    getSIPProtocol();
    public ObjectName    getKeepAlive();
    public MBeanNotificationInfo[]    getNotificationInfo();
    public ObjectName    getRequestProcessing();
    public void    removeAccessLog();
    public void    removeConnectionPool();
    public void    removeSIPListenerById( final String key );
    public void    removeSIPProtocol();
    public void    removeKeepAlive();
    public void    removeNotificationListener( final NotificationListener param1 );
    public void    removeNotificationListener( final NotificationListener param1, final NotificationFilter param2, final Object param3 );
    public void    removeRequestProcessing();
    public void    sendNotification( final javax.management.Notification param1 );
}
