/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License).  You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 */

package org.jvnet.glassfish.comms.admin.management.extensions.support.oldconfig;

import javax.management.NotificationListener;
import javax.management.NotificationFilter;
import javax.management.AttributeList;
import javax.management.ObjectName;
import javax.management.MBeanNotificationInfo;

public interface OldSIPProtocolMBean 
{
    public boolean getErrorResponseEnabled();
    public void    setErrorResponseEnabled( final boolean value );

    public boolean getDefaultTcpTransport();
    public void    setDefaultTcpTransport( final boolean value );


// -------------------- Operations --------------------
    public ObjectName       createSIPLink( final AttributeList attribute_list );
    public ObjectName       getSIPLink();
    public void             removeSIPLink();

    public ObjectName       createSIPTimers( final AttributeList attribute_list );
    public ObjectName       getSIPTimers();
    public void             removeSIPTimers();

    public void    addNotificationListener( final NotificationListener param1, final NotificationFilter param2, final Object param3 );
    public boolean    destroyConfigElement();
    public String    getDefaultAttributeValue( final String attributeName );
    public MBeanNotificationInfo[]    getNotificationInfo();
    public void    removeNotificationListener( final NotificationListener param1 );
    public void    removeNotificationListener( final NotificationListener param1, final NotificationFilter param2, final Object param3 );
    public void    sendNotification( final javax.management.Notification param1 );

}
