/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License).  You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 */

package org.jvnet.glassfish.comms.management.config;

/**
    Keys for use with {@link AvailabilityServiceConfig}
    
    All Map values associated with a key are of class java.lang.String
    unless otherwise documented.
 */
public final class SIPContainerAvailabilityConfigKeys
{
    private    SIPContainerAvailabilityConfigKeys()    {}
    
    /** SIP container availability enabled*/
    public static final String SIP_CONTAINER_AVAILABILITY_ENABLED_KEY = "AvailabilityEnabled";
    /** Persistence type*/
    public static final String PERSISTENCE_TYPE_KEY = "PersistenceType";
    /** Persistence frequency*/
    public static final String PERSISTENCE_FREQUENCY_KEY = "PersistenceFrequency";
    /** Persistence scope*/
    public static final String PERSISTENCE_SCOPE_KEY = "PersistenceScope";
    /** Repair during failure*/
    public static final String REPAIR_DURING_FAILURE_KEY = "RepairDuringFailure";
}
