/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License).  You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 */

package org.jvnet.glassfish.comms.management.config;

/**
    Keys for use with {@link SIPServiceConfig#createSIPLinkConfig}
    
    All Map values associated with a key are of class java.lang.String
    unless otherwise documented.
 */
public final class SIPLinkConfigKeys
{
    private    SIPLinkConfigKeys()    {}
    
    public static final String CONNECTION_ALIVE_TIMEOUT_IN_SECONDS_KEY = "ConnectionAliveTimeoutInSeconds";
    public static final String MAX_QUEUE_LENGTH_KEY = "MaxQueueLength";
    public static final String WRITE_TIMEOUT_IN_MILLIS_KEY = "WriteTimeoutInMillis";
    public static final String WRITE_TIMEOUT_RETRIES_KEY = "WriteTimeoutRetries";
}
