/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 * Copyright (c) Ericsson AB, 2004-2008. All rights reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or glassfish/bootstrap/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at glassfish/bootstrap/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package org.jvnet.glassfish.comms.deployment.io;

import com.sun.enterprise.deployment.Descriptor;
import com.sun.enterprise.deployment.node.RootXMLNode;
import com.sun.enterprise.deployment.node.web.WebBundleNode;
import com.sun.enterprise.deployment.io.DeploymentDescriptorFile;

import org.jvnet.glassfish.comms.deployment.backend.DescriptorConstants;
import org.jvnet.glassfish.comms.deployment.node.sip.SipBundleNode;

/**
 * This class is responsible for handling sip.xml files
 *
 * @author Prasad Subramanian
 */
public class SipDeploymentDescriptorFile extends DeploymentDescriptorFile {
    
    public final static String DESC_PATH = "WEB-INF/sip.xml";            
    
    /** Creates a new instance of WebDeploymentDescriptorFile */
    public SipDeploymentDescriptorFile() {
    }
    
    /**
     * @return the location of the DeploymentDescriptor file for a
     * particular type of this Archive
     */
    public String getDeploymentDescriptorPath() {
        return DescriptorConstants.SIP_JAR_ENTRY;        
    }
    
    /**
     * @return a RootXMLNode responsible for handling the deployment
     * descriptors associated with this module
     *
     * @param the descriptor for which we need the node
     */
    public RootXMLNode getRootXMLNode(Descriptor descriptor) {
        return new SipBundleNode(descriptor);        
    }
    
}
