/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 * Copyright (c) Ericsson AB, 2004-2008. All rights reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or glassfish/bootstrap/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at glassfish/bootstrap/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package org.jvnet.glassfish.comms.deployment.util;

/**
 *
 * @author Prasad Subramanian
 */
public interface SipTagNames {
    
    public static final String  SIP_BUNDLE = "sip-app";
    public static final String  APP_NAME = "app-name";
    public static final String  SERVLET = "servlet";
    public static final String  SERVLET_MAPPING = "servlet-mapping";
    public static final String  SERVLET_NAME = "servlet-name";    
    public static final String  PATTERN = "pattern";
    public static final String  AND = "and";
    public static final String  OR = "or";
    public static final String  NOT = "not";
    public static final String  EQUALS = "equal";
    public static final String  EXISTS = "exists";
    public static final String  CONTAINS = "contains";    
    public static final String  SUBDOMAINOF = "subdomain-of";
    public static final String  VAR = "var";
    public static final String  VALUE = "value";    
    public static final String  IGNORE_CASE = "ignore-case";
    public static final String  PROXY_CONFIG = "proxy-config";
    public static final String  PROXY_TIMEOUT = "proxy-timeout";
    public static final String  SESSION_CONFIG = "session-config";
    public static final String  SESSION_TIMEOUT = "session-timeout";
    public static final String  SEQUENTIAL_SEARCH_TIMEOUT = 
                                      "sequential-search-timeout";
    public static final String  DISPLAY_NAME = "display-name";
    public static final String  DESCRIPTION = "description";    
    public static final String  DISTRIBUTABLE = "distributable";    
    public static final String  SIP_RESOURCE_COLLECTION = "resource-collection";
    public static final String  RESOURCE_NAME = "resource-name";
    public static final String  PROXY_AUTHENTICATION = "proxy-authentication";
    public static final String  SIP_METHOD = "sip-method";
    public static final String  AUTH_CONSTRAINT = "auth-constraint";

    
}
